=== debian/changelog ===
ldc (1:1.6.0-1) unstable; urgency=medium

  * New upstream version: 1.6.0
  * Update Phobos package name/contents for new runtime/stdlib
  * Bump standards version: No changes needed

 -- Matthias Klumpp <mak@debian.org>  Wed, 03 Jan 2018 21:28:00 +0100
