=== debian/control ===
Source: ldc
Section: devel
Priority: optional
Maintainer: Debian D Language Group <pkg-d-devel@lists.alioth.debian.org>
Uploaders: Konstantinos Margaritis <markos@debian.org>,
           Matthias Klumpp <mak@debian.org>
Build-Depends: cmake,
               debhelper (>= 10),
               dh-exec (>= 0.3),
#               ldc <!stage1>,
               libconfig++-dev,
               libconfig-dev,
               libcurl4-gnutls-dev,
               libedit-dev,
               libffi-dev,
               libtinfo-dev,
               llvm-5.0-dev,
               pkg-config (>= 0.20),
               quilt (>= 0.40),
               zlib1g-dev
Standards-Version: 4.1.2
Homepage: https://github.com/ldc-developers/ldc
Vcs-Browser: https://anonscm.debian.org/git/pkg-d/ldc.git
Vcs-Git: https://anonscm.debian.org/git/pkg-d/ldc.git

Package: ldc
Architecture: amd64 arm64 armhf i386 ppc64 ppc64el
Provides: d-compiler,
          d-v2-compiler
Depends: libphobos2-ldc-dev (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: LLVM D Compiler
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 This is the actual ldc compiler

Package: libphobos2-ldc76
Section: libs
Architecture: amd64 arm64 armhf i386 ppc64 ppc64el
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libphobos2-ldc75
Description: LLVM D Compiler - Phobos2 Standard library, shared objects
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 This package includes the libraries for the Phobos standard library.

Package: libphobos2-ldc-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386 ppc64 ppc64el
Depends: libphobos2-ldc76 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: LLVM D Compiler - Phobos2 Standard library, imports
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 This package includes the D imports for the Phobos standard library.
